
#include <stdio.h>
#define NRANSI
#include "nr.h"
# include "nrutil.h"
#include <math.h>
#define TINY 1.0e-20
#define MAXIT 100
#define EPS 3.0e-7
#define FPMIN 1.0e-30
#include <stdio.h>
static int  chan, onoff, zeit, ton, vol, maxzeit,minzeit,
chanwahl, i, j, bit = 1, p, n,ende=5;
static unsigned long l;
float melodie[111],abschnitt[111];
float korrel,prob,z,maxkorrel=0,minkorrel=1111;
FILE *datei,*motiv;


/* Driver for routine pearsn */


float betacf(float a, float b, float x)
{
/*	void nrerror(char error_text[]); */
	int m,m2;
	float aa,c,d,del,h,qab,qam,qap;

	qab=a+b;
	qap=a+1.0;
	qam=a-1.0;
	c=1.0;
	d=1.0-qab*x/qap;
	if (fabs(d) < FPMIN) d=FPMIN;
	d=1.0/d;
	h=d;
	for (m=1;m<=MAXIT;m++) {
		m2=2*m;
		aa=m*(b-m)*x/((qam+m2)*(a+m2));
		d=1.0+aa*d;
		if (fabs(d) < FPMIN) d=FPMIN;
		c=1.0+aa/c;
		if (fabs(c) < FPMIN) c=FPMIN;
		d=1.0/d;
		h *= d*c;
		aa = -(a+m)*(qab+m)*x/((a+m2)*(qap+m2));
		d=1.0+aa*d;
		if (fabs(d) < FPMIN) d=FPMIN;
		c=1.0+aa/c;
		if (fabs(c) < FPMIN) c=FPMIN;
		d=1.0/d;
		del=d*c;
		h *= del;
		if (fabs(del-1.0) < EPS) break;
	}
	if (m > MAXIT) puts("a or b too big, or MAXIT too small in betacf");
	return h;
}
float gammln(float xx)
{
	double x,y,tmp,ser;
	static double cof[6]={76.18009172947146,-86.50532032941677,
		24.01409824083091,-1.231739572450155,
		0.1208650973866179e-2,-0.5395239384953e-5};
	int j;

	y=x=xx;
	tmp=x+5.5;
	tmp -= (x+0.5)*log(tmp);
	ser=1.000000000190015;
	for (j=0;j<=5;j++) ser += cof[j]/++y;
	return -tmp+log(2.5066282746310005*ser/x);
}
float betai(float a, float b, float x)
{
	float betacf(float a, float b, float x);
	float gammln(float xx);
/*	void nrerror(char error_text[]);  */
	float bt;

	if (x < 0.0 || x > 1.0) puts("Bad x in routine betai");
	if (x == 0.0 || x == 1.0) bt=0.0;
	else
		bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.0-x));
	if (x < (a+1.0)/(a+b+2.0))
		return bt*betacf(a,b,x)/a;
	else
		return 1.0-bt*betacf(b,a,1.0-x)/b;
}

void pearsn(float x[], float y[], unsigned long n, float *r, float *prob,
	float *z)
{
	float betai(float a, float b, float x);
	float erfcc(float x);
	unsigned long j;
	float yt,xt,t,df;
	float syy=0.0,sxy=0.0,sxx=0.0,ay=0.0,ax=0.0;

	for (j=1;j<=n;j++) {
		ax += x[j];
		ay += y[j];
	}
	ax /= n;
	ay /= n;
	for (j=1;j<=n;j++) {
		xt=x[j]-ax;
		yt=y[j]-ay;
		sxx += xt*xt;
		syy += yt*yt;
		sxy += xt*yt;
	}
	*r=sxy/(sqrt(sxx*syy)+TINY);
	*z=0.5*log((1.0+(*r)+TINY)/(1.0-(*r)+TINY));
	df=n-2;
	t=(*r)*sqrt(df/((1.0-(*r)+TINY)*(1.0+(*r)+TINY)));
	*prob=betai(0.5*df,0.5,df/(df+t*t));
} 
/*=============== U. progr. Zeilelesen ==================================*/
int lieszeile()
{
	int wrongchan;
	do{
		ende=fscanf(datei,"%d%d%d%d%d",&chan,&onoff,&zeit,&ton,&vol);
		p=1;
		p=p << chan; 
		wrongchan=(p&chanwahl) == 0;
	}while( (!onoff  || wrongchan) && (ende == 5));
}

/*=============== Thema laden  ==================================*/
int ladthema()
{
	int i=0;
	do{
		ende=fscanf(motiv,"%d%d%d%d%d",&chan,&onoff,&zeit,&ton,&vol);
		if(onoff ) melodie[i++]=ton;
	}while (ende==5);
	l=i;
	for(i=0;i<l;i++) fprintf(stderr," %5.1f ",melodie[i]); 
	fprintf(stderr,"\n\n\n");
}

/*===========================U.progr. schieb=============================*/
int schieb()
{
	int i,j,k;

	for(i=0;i<(l-1);i++) abschnitt[i]=  abschnitt[i+1];
	lieszeile();
	abschnitt[l-1]=ton;
}

/*==========================Abschnitt laden==============================*/
int laden()
{
	int i=0;
	do{
			lieszeile();abschnitt[i++]=ton;
	} while (i<l);
}

/*==============================Hauptprogramm============================*/
int
main (cpar, vpar)
int cpar;
char *vpar[];
{ /*.................Eroeffnung........................................... */
	if (cpar < 4)
		goto schluss;
	chanwahl = 0;
	fprintf (stderr, "%s  %s\n", vpar[1],vpar[2]);
	datei = fopen (vpar[1], "r"); 
	motiv = fopen(vpar[2],"r");
	if ((datei == NULL)|| (motiv == NULL))
		goto schluss; 
/*.........................Kanalwahl.................................... */
	for (n = 3; n < cpar; n++)
	{
		i = atoi (vpar[n]);
		fprintf (stderr, "%d\n", i);
		if ((i < 0) || (i > 15))
			goto schluss;
		bit = 1;
		bit = bit << i;
		chanwahl = chanwahl | bit;
	}  
	ladthema(); 
	laden();
	/*..................Einlesen und auswaehlen.......................... */
	do{
       korrel=0;prob=0;z=0;
	pearsn(abschnitt,melodie,l,&korrel,&prob,&z);
/*	printf("\n%30s %16s\n","PEARSN","Expected");
	printf("%s %8s %9f %15f\n","Corr. Coeff."," ",korrel,0.9069586);
	printf("%s %9s %9f %15f\n","Probability"," ",prob,0.2926505e-3);
	printf("%s %10s %9f %15f\n","Fisher's z"," ",z,1.510110); */


		if (korrel>maxkorrel){ 
			maxkorrel=korrel;
			maxzeit=zeit;}
		if (korrel<minkorrel){ 
			minkorrel=korrel;
			minzeit=zeit;}
			if(korrel > 0.9){
				for(i=0;i<l;i++)printf("%4.0f ",melodie[i]);
				printf("\n");
				for(i=0;i<l;i++)printf("%4.0f ",abschnitt[i]);
			printf("\n korrelat.koeff.= %f Zeit %d\n\n",korrel,zeit);
				}
		

		schieb();
	}while(ende ==5);
	printf("\n\n\nGroesster Korrelationskoeffizient und Zeit %lf %d\n",
          maxkorrel,maxzeit);
	printf("\nKleinster Korrelationskoeffizient und Zeit %lf %d\n",
          minkorrel,minzeit);
	goto ok;
schluss:
	puts ("Abbruch, Fehleingabe");
ok:
	fclose (datei);
	close (melodie);
}
#undef NRANSI
#undef MAXIT
#undef EPS
#undef FPMIN
#undef TINY
